#ifndef INTMASK_H
#define INTMASK_H
#include "cytypes.h"
#include "core_cm3_psoc5.h"

__attribute__((always_inline)) static inline uint32_t getInterruptMask(void)
  { uint32_t result;
    __asm volatile ("MRS %0, basepri" : "=r" (result) );
    return(result >> (8 - __NVIC_PRIO_BITS));
  }

__attribute__((always_inline)) static inline uint32_t setInterruptMask(uint32_t level)
  { uint32_t result;
    level = level << (8 - __NVIC_PRIO_BITS);
    __asm volatile ("MRS %0, basepri" : "=r" (result) );
    __asm volatile ("MSR basepri, %0" : : "r" (level) : "memory");
    return(result);
  }

#endif